/*
 * tim.c
 *
 *  Created on: 2024622
 *      Author: psx
 */

#include "tim.h"
#include "timeSliceOffset.h"
#include "pwm.h"
#include "mppt_control.h"
#include "task.h"

void TIM3_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void TIM2_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void SysTick_Handler(void) __attribute__((interrupt("WCH-Interrupt-fast")));

void TIM1_UP_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));


void TIM3_Init(uint16_t delay_ms)
{
    /* Ƶϵ */
    uint16_t psc = (SystemCoreClock / 10000) - 1;
    /*  */
    uint16_t arr = delay_ms * 1 - 1;

    TIM3_Int_Init(arr, psc);
}

void TIM3_Int_Init(uint16_t arr, uint16_t psc)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
    NVIC_InitTypeDef NVIC_InitStructure;

    RCC_PB1PeriphClockCmd(RCC_PB1Periph_TIM3, ENABLE); //ʹTIM3ʱ

    TIM_TimeBaseStructure.TIM_Period = arr;   //ָ´θ¼ʱҪصԶ¼ؼĴеֵ
    TIM_TimeBaseStructure.TIM_Prescaler = psc; //ָڻTIMʱӵԤƵֵ
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;     //ʱӷƵ
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up; //TIMģʽϼģʽ
    TIM_TimeBaseInit(TIM3, &TIM_TimeBaseStructure); //ָĲʼTIMxʱλ

    TIM_ITConfig(TIM3, TIM_IT_Update, ENABLE ); //ʹTIM3жϣж

    //ʼTIM NVICжȼ
    NVIC_InitStructure.NVIC_IRQChannel = TIM3_IRQn;           //TIM3ж
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0; //ռȼ0
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;        //Ӧȼ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;           //ʹͨ1ж
    NVIC_Init(&NVIC_InitStructure); //ʼNVIC

//    TIM_Cmd(TIM3, ENABLE); //TIM3ʹ
}

void TIM3_IRQHandler(void)
{
    if (TIM_GetITStatus(TIM3, TIM_IT_Update) != RESET) { //TIM3жǷ
        TIM_ClearITPendingBit(TIM3, TIM_IT_Update);    //TIM3жϹλ
        test();
    }
}

void TIM2_Init(uint16_t delay_ms)
{
    /* Ƶϵ */
    uint16_t psc = (SystemCoreClock / 10000) - 1;
    /* ֵ */
    uint16_t arr = delay_ms * 10 - 1;

    TIM2_Int_Init(arr, psc);
}

void TIM2_Int_Init(uint16_t arr, uint16_t psc)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
    NVIC_InitTypeDef NVIC_InitStructure;

    RCC_PB1PeriphClockCmd(RCC_PB1Periph_TIM2, ENABLE); //ʹTIM2ʱ

    TIM_TimeBaseStructure.TIM_Period = arr;   //ָ´θ¼ʱҪصԶ¼ؼĴеֵ
    TIM_TimeBaseStructure.TIM_Prescaler = psc; //ָڻTIMʱӵԤƵֵ
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;     //ʱӷƵ
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up; //TIMģʽϼģʽ
    TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure); //ָĲʼTIMxʱλ

    TIM_ITConfig(TIM2, TIM_IT_Update, ENABLE); //ʹTIM2жϣж

    //ʼTIM NVICжȼ
    NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;           //TIM2ж
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0; //ռȼ0
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;        //Ӧȼ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;           //ʹͨ1ж
    NVIC_Init(&NVIC_InitStructure); //ʼNVIC

    TIM_Cmd(TIM2, ENABLE); //TIM2ʹ
}

void TIM2_IRQHandler(void)
{
    if (TIM_GetITStatus(TIM2, TIM_IT_Update) != RESET) {    //TIM2жǷ
        TIM_ClearITPendingBit(TIM2, TIM_IT_Update);         //TIM1жϹλ
        TimeSliceOffset_Produce();
//        if (outputAgainFlag == 1) {
//            outputAgainFlag = 0;
//        }
    }
}

//SysTickʼ          1MSһж
static void SysTick_Config(uint32_t ticks)
{
    SysTick->SR = 0;
    SysTick->CNT = 0;
    SysTick->CMP = ticks;
    SysTick->CTLR =0xF;

    NVIC_SetPriority(SysTicK_IRQn, 15);
    NVIC_EnableIRQ(SysTicK_IRQn);
}

void Systick_Init(void)
{
    SysTick_Config((SystemCoreClock / 1000) - 1);
}

void SysTick_Handler(void)
{
    SysTick->SR = 0;
    TimeSliceOffset_Produce();
}

void TIM1_Init(uint16_t delay_ms)
{
    /* Ƶϵ */
    uint16_t psc = (SystemCoreClock / 10000) - 1;
    /*  */
    uint16_t arr = delay_ms * 10 - 1;
//    uint16_t arr = 10 - 1;

    TIM1_Int_Init(arr, psc);
}

void TIM1_Int_Init(uint16_t arr, uint16_t psc)
{
    TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
    NVIC_InitTypeDef NVIC_InitStructure;

    RCC_PB2PeriphClockCmd(RCC_PB2Periph_TIM1, ENABLE); //ʹTIM1ʱ

    TIM_TimeBaseStructure.TIM_Period = arr;   //ָ´θ¼ʱҪصԶ¼ؼĴеֵ
    TIM_TimeBaseStructure.TIM_Prescaler = psc; //ָڻTIMʱӵԤƵֵ
    TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;     //ʱӷƵ
    TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up; //TIMģʽϼģʽ
    TIM_TimeBaseInit(TIM1, &TIM_TimeBaseStructure); //ָĲʼTIMxʱλ
    TIM_ITConfig(TIM1, TIM_IT_Update, ENABLE); //ʹTIM1жϣж

    //ʼTIM NVICжȼ
    NVIC_InitStructure.NVIC_IRQChannel = TIM1_UP_IRQn;           //TIM1ж
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;   //ռȼ0
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 3;          //Ӧȼ3
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;             //ʹͨж
    NVIC_Init(&NVIC_InitStructure); //ʼNVIC

    TIM_Cmd(TIM1, ENABLE); //TIM1ʹ
}

void TIM1_UP_IRQHandler(void)
{
    if (TIM_GetITStatus(TIM1, TIM_IT_Update) != RESET) {    //TIM1жǷ
        TIM_ClearITPendingBit(TIM1, TIM_IT_Update);         //TIM1жϹλ
        printf("in tim1 irq \n");
    }
}

